import type { RequestBody, ResponseBody, RequestHeaders, ResponseHeaders, Params } from "../index.js";
export { ClientError } from "./error.js";
declare const _default: {
    get: <R extends never>(route: R, request: {
        params: Params<R>;
        headers: RequestHeaders<"GET", R>;
        body: RequestBody<"GET", R>;
    }) => Promise<{
        headers: ResponseHeaders<"GET", R>;
        body: ResponseBody<"GET", R>;
    }>;
    put: <R_1 extends never>(route: R_1, request: {
        params: Params<R_1>;
        headers: RequestHeaders<"PUT", R_1>;
        body: RequestBody<"PUT", R_1>;
    }) => Promise<{
        headers: ResponseHeaders<"PUT", R_1>;
        body: ResponseBody<"PUT", R_1>;
    }>;
    post: <R_2 extends never>(route: R_2, request: {
        params: Params<R_2>;
        headers: RequestHeaders<"POST", R_2>;
        body: RequestBody<"POST", R_2>;
    }) => Promise<{
        headers: ResponseHeaders<"POST", R_2>;
        body: ResponseBody<"POST", R_2>;
    }>;
    head: <R_3 extends never>(route: R_3, request: {
        params: Params<R_3>;
        headers: RequestHeaders<"HEAD", R_3>;
        body: RequestBody<"HEAD", R_3>;
    }) => Promise<{
        headers: ResponseHeaders<"HEAD", R_3>;
        body: ResponseBody<"HEAD", R_3>;
    }>;
    patch: <R_4 extends never>(route: R_4, request: {
        params: Params<R_4>;
        headers: RequestHeaders<"PATCH", R_4>;
        body: RequestBody<"PATCH", R_4>;
    }) => Promise<{
        headers: ResponseHeaders<"PATCH", R_4>;
        body: ResponseBody<"PATCH", R_4>;
    }>;
    delete: <R_5 extends never>(route: R_5, request: {
        params: Params<R_5>;
        headers: RequestHeaders<"DELETE", R_5>;
        body: RequestBody<"DELETE", R_5>;
    }) => Promise<{
        headers: ResponseHeaders<"DELETE", R_5>;
        body: ResponseBody<"DELETE", R_5>;
    }>;
};
export default _default;
